GeekOS(project-1)编译、安装、运行

一、安装Ubuntu环境

本文实验环境:Ubuntu 18.04

二、下载GeekOS

进入很久没有维护了的官方网站,点击左侧的Downloads,或How do I get it?下方的downloads section,然后点击Download Latest Version下载并解压。当前版本为geekos-0.3.0,最后修改日期为2005-04-12

三、编译

安装编译环境

通过sudo apt-get install ***来分别安装build-essentialnasmbochsbochs-x

安装低版本gcc

通过gcc -v可以查看当前的gcc版本,目前我的版本是7.3.0。而需要编译的geekos-0.3版本非常古老,直接编译会出现一堆错误,所以使用同样比较古老的gcc-4.8来进行编译。

首先通过sudo apt-get install gcc-4.8安装,然后输入ls /usr/bin/gcc* -l来查看已安装版本:

然后分别为新旧版本设置优先级,自己设置100测试没有问题:

$ sudo update-alternatives --install /usr/bin/gcc gcc /usr/bin/gcc-4.8 100
$ sudo update-alternatives --install /usr/bin/gcc gcc /usr/bin/gcc-7 100

然后通过以下指令选择不同的gcc版本:
$ sudo update-alternatives --config gcc

选择gcc版本

选择完成之后,通过gcc -v来查看是否切换成功:

正式编译

进入geekos-0.3.0/src/project0/build/目录,直接开始编译:

$ make depend
$ make

但是当然不会这么顺利,除了上面提到的gcc版本问题,还有一堆可能碰到的问题,顺便附上我的解决方法。每次尝试解决问题之后,可能需要make clean之后再次重新编译。

warnings being treated as errors

这是因为Makefile中默认的编译选项过于严格,把警告都当成错误来看待,我们可以修改一下Makefile将这个过于严格的编译选项去掉(该文件位于build目录下):
Makefile的第149行删除-Werror

// 修改前:
CC_GENERAL_OPTS := $(GENERAL_OPTS) -Werror 
// 修改后:
CC_GENERAL_OPTS := $(GENERAL_OPTS)

或者,打开src/project0/include/geekos/segment.h,在第43行加上:8

//修改前:
uchar_t baseHigh        PACKED ;
// 修改后:
uchar_t baseHigh   : 8  PACKED ;

x86-64与i386输出不兼容


这是在64位机器的默认配置下导致的,我们可以强制增加编译选项-m32和链接选项-m elf_i386,打开Makefile,将第100、106、109行修改如下:

# Target C compiler.  gcc 2.95.2 or later should work.
TARGET_CC := $(TARGET_CC_PREFIX)gcc -m32

# Host C compiler.  This is used to compile programs to execute on
# the host platform, not the target (x86) platform.  On x86/ELF
# systems, such as Linux and FreeBSD, it can generally be the same
# as the target C compiler.
HOST_CC := gcc -m32

# Target linker.  GNU ld is probably to only one that will work.
TARGET_LD := $(TARGET_CC_PREFIX)ld -m elf_i386

bits目录下缺失文件

这是gcc环境没有安装完善导致的,安装命令:

$ sudo apt-get install gcc-multilib

__stack_chk_fail未定义


这是因为gcc在编译时开启了栈保护,打开Makefile,在第148行关闭栈保护:

# Flags used for all C source files
// 修改前:
GENERAL_OPTS := -O -Wall $(EXTRA_C_OPTS)
// 修改后:
GENERAL_OPTS := -O -Wall -fno-stack-protector $(EXTRA_C_OPTS)

最终编译成功之后,会在build目录下生成一个镜像文件fd.img和bochs模拟器的配置文件.bochsrc

四、运行

通过bochs命令运行:

运行当然也没有那么顺利:

>>PANIC<<

bochs第一次启动会出现>>PANIC<< .bochsrc:4: vgaromimage directive malformed.错误,打开.bochsrc

  1. 把第4行注释掉
# vgaromimage: /export/home/daveho/linux/bochs-2.0.2/share/bochs/VGABIOS-lgpl-latest
  1. 在第5、6行修改:
// 修改前:
romimage: file=/export/home/daveho/linux/bochs-2.0.2/share/bochs/BIOS-bochs-latest, address=0xf0000
// 修改后:
romimage: file=$BXSHARE/BIOS-bochs-latest 
  1. 把第16、18、22行注释掉
# floppy_command_delay: 500 
# ips:  1000000 
# newharddrivesupport: enabled=1

黑屏

如果新弹出的bochs窗口黑屏,可能是进入了调试模式,在终端中输入c回车,就可以了。

failed assertion in init_idt

输入c回车之后,虽然窗口出现文字,但是仍然报错。这里可以尝试使用较低版本的nasm重新编译运行,记得要make clean

首先去nasm官网下载低版本,这里我尝试的是2.00版本,测试成功。下载nasm-2.00.tar.gz压缩包并解压之后,在nasm-2.00目录中打开终端,输入以下指令安装:

$ ./configure
$ make
$ sudo make install

然后通过nasm -v指令查看当前版本,并在geekos相关目录中make clean之后重新编译运行即可。

nasm版本

成功运行界面:

推荐阅读更多精彩内容